searchNodes=[{"doc":"Application entry point. cf. https://hexdocs.pm/elixir/1.12/Application.html","ref":"Discogs.Application.html","title":"Discogs.Application","type":"module"},{"doc":"Callback implementation for Application.start/2 .","ref":"Discogs.Application.html#start/2","title":"Discogs.Application.start/2","type":"function"},{"doc":"Entry-point for the CLI app. This is used as escript 's :main_module . cf. https://elixirschool.com/en/lessons/advanced/escripts/","ref":"Discogs.CLI.html","title":"Discogs.CLI","type":"module"},{"doc":"Parses the ARGV and either syncs or shuffles a user's collection, depending on the arguments given. Options include: --sync USER -&gt; sync_collection/1 --shuffle USER &lt;N&gt; -&gt; shuffle_collection/2 Invalid or no arguments defer to the usage doc.","ref":"Discogs.CLI.html#main/1","title":"Discogs.CLI.main/1","type":"function"},{"doc":"Shuffles records a user's collection, returning n = num_records .","ref":"Discogs.CLI.html#shuffle_collection/2","title":"Discogs.CLI.shuffle_collection/2","type":"function"},{"doc":"Fetches a user's collection from Discogs, persists all associated models to the local db and updates the user's collection if had been stored previously.","ref":"Discogs.CLI.html#sync_collection/1","title":"Discogs.CLI.sync_collection/1","type":"function"},{"doc":"Ecto model representing a Discogs artist.","ref":"Discogs.Models.Artist.html","title":"Discogs.Models.Artist","type":"module"},{"doc":"Validates the params and returns an Ecto changeset on success.","ref":"Discogs.Models.Artist.html#changeset/2","title":"Discogs.Models.Artist.changeset/2","type":"function"},{"doc":"Creates the Artist .","ref":"Discogs.Models.Artist.html#create/1","title":"Discogs.Models.Artist.create/1","type":"function"},{"doc":"Gets the Artist by discogs id.","ref":"Discogs.Models.Artist.html#get_by_discogs_id/1","title":"Discogs.Models.Artist.get_by_discogs_id/1","type":"function"},{"doc":"Gets or creates the Artist .","ref":"Discogs.Models.Artist.html#get_or_create/1","title":"Discogs.Models.Artist.get_or_create/1","type":"function"},{"doc":"","ref":"Discogs.Models.Artist.html#t:attr_map/0","title":"Discogs.Models.Artist.attr_map/0","type":"type"},{"doc":"","ref":"Discogs.Models.Artist.html#t:discogs_id/0","title":"Discogs.Models.Artist.discogs_id/0","type":"type"},{"doc":"Ecto model representing a Discogs artist-to-release relationship.","ref":"Discogs.Models.ArtistRelease.html","title":"Discogs.Models.ArtistRelease","type":"module"},{"doc":"Ecto model representing a record belonging to a Discogs release. This is not a first-class object in Discogs's data model. What this allows us to do is to join over from User -&gt; Release -&gt; Record and pick out a sampling of specific records in a user's collection at random (for example, disc 2 of a 2xLP set). See Discogs.CLI.shuffle_collection/2 for example usage.","ref":"Discogs.Models.Record.html","title":"Discogs.Models.Record","type":"module"},{"doc":"Validates the params and returns an Ecto changeset on success.","ref":"Discogs.Models.Record.html#changeset/2","title":"Discogs.Models.Record.changeset/2","type":"function"},{"doc":"Formats the Record name for consumption by the Discogs.Repo (or elsewhere). If the record is part of a 2+xLP set, appends the disc number; else delegates to the release name. TODO: This should be done by implementing String.Chars . cf. https://elixirschool.com/en/lessons/advanced/protocols/ This would allow us to: simply call the stringified value of the release, rather than passing around a formatter consume the stringfied value of the record similarly elsewhere (i.e., via simple interpolation without a method call). This works similarly to defining #to_s in Ruby.","ref":"Discogs.Models.Record.html#format_name/2","title":"Discogs.Models.Record.format_name/2","type":"function"},{"doc":"Ecto model representing a Discogs release.","ref":"Discogs.Models.Release.html","title":"Discogs.Models.Release","type":"module"},{"doc":"Validates the params and returns an Ecto changeset on success.","ref":"Discogs.Models.Release.html#changeset/2","title":"Discogs.Models.Release.changeset/2","type":"function"},{"doc":"Formats the Release name for consumption by the Discogs.Repo (or elsewhere). TODO: This should be done by implementing String.Chars. cf. https://elixirschool.com/en/lessons/advanced/protocols/","ref":"Discogs.Models.Release.html#format_name/1","title":"Discogs.Models.Release.format_name/1","type":"function"},{"doc":"Gets the Release by discogs id.","ref":"Discogs.Models.Release.html#get_by_discogs_id/1","title":"Discogs.Models.Release.get_by_discogs_id/1","type":"function"},{"doc":"Gets the Release or an Ecto changeset ready for insert.","ref":"Discogs.Models.Release.html#get_struct_or_changeset/1","title":"Discogs.Models.Release.get_struct_or_changeset/1","type":"function"},{"doc":"","ref":"Discogs.Models.Release.html#t:attr_map/0","title":"Discogs.Models.Release.attr_map/0","type":"type"},{"doc":"","ref":"Discogs.Models.Release.html#t:changeset/0","title":"Discogs.Models.Release.changeset/0","type":"type"},{"doc":"","ref":"Discogs.Models.Release.html#t:discogs_id/0","title":"Discogs.Models.Release.discogs_id/0","type":"type"},{"doc":"","ref":"Discogs.Models.Release.html#t:release/0","title":"Discogs.Models.Release.release/0","type":"type"},{"doc":"","ref":"Discogs.Models.Release.html#t:result/0","title":"Discogs.Models.Release.result/0","type":"type"},{"doc":"Ecto model representing a Discogs user.","ref":"Discogs.Models.User.html","title":"Discogs.Models.User","type":"module"},{"doc":"Validates the params and returns an Ecto changeset on success.","ref":"Discogs.Models.User.html#changeset/2","title":"Discogs.Models.User.changeset/2","type":"function"},{"doc":"Creates the User .","ref":"Discogs.Models.User.html#create_by_name/1","title":"Discogs.Models.User.create_by_name/1","type":"function"},{"doc":"Gets the User by name.","ref":"Discogs.Models.User.html#get_by_name/1","title":"Discogs.Models.User.get_by_name/1","type":"function"},{"doc":"Gets or creates the User .","ref":"Discogs.Models.User.html#get_or_create_by_name/1","title":"Discogs.Models.User.get_or_create_by_name/1","type":"function"},{"doc":"Ecto model representing a Discogs user-to-release relationship.","ref":"Discogs.Models.UserRelease.html","title":"Discogs.Models.UserRelease","type":"module"},{"doc":"Defines the Ecto repository. cf. https://hexdocs.pm/ecto/Ecto.Repo.html","ref":"Discogs.Repo.html","title":"Discogs.Repo","type":"module"},{"doc":"Callback implementation for Ecto.Repo.aggregate/4 .","ref":"Discogs.Repo.html#aggregate/4","title":"Discogs.Repo.aggregate/4","type":"function"},{"doc":"Callback implementation for Ecto.Repo.all/2 .","ref":"Discogs.Repo.html#all/2","title":"Discogs.Repo.all/2","type":"function"},{"doc":"","ref":"Discogs.Repo.html#child_spec/1","title":"Discogs.Repo.child_spec/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.config/0 .","ref":"Discogs.Repo.html#config/0","title":"Discogs.Repo.config/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete/2 .","ref":"Discogs.Repo.html#delete/2","title":"Discogs.Repo.delete/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete!/2 .","ref":"Discogs.Repo.html#delete!/2","title":"Discogs.Repo.delete!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete_all/2 .","ref":"Discogs.Repo.html#delete_all/2","title":"Discogs.Repo.delete_all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get/3 .","ref":"Discogs.Repo.html#get/3","title":"Discogs.Repo.get/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get!/3 .","ref":"Discogs.Repo.html#get!/3","title":"Discogs.Repo.get!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by/3 .","ref":"Discogs.Repo.html#get_by/3","title":"Discogs.Repo.get_by/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by!/3 .","ref":"Discogs.Repo.html#get_by!/3","title":"Discogs.Repo.get_by!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.in_transaction?/0 .","ref":"Discogs.Repo.html#in_transaction?/0","title":"Discogs.Repo.in_transaction?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert/2 .","ref":"Discogs.Repo.html#insert/2","title":"Discogs.Repo.insert/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert!/2 .","ref":"Discogs.Repo.html#insert!/2","title":"Discogs.Repo.insert!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_all/3 .","ref":"Discogs.Repo.html#insert_all/3","title":"Discogs.Repo.insert_all/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update/2 .","ref":"Discogs.Repo.html#insert_or_update/2","title":"Discogs.Repo.insert_or_update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update!/2 .","ref":"Discogs.Repo.html#insert_or_update!/2","title":"Discogs.Repo.insert_or_update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.load/2 .","ref":"Discogs.Repo.html#load/2","title":"Discogs.Repo.load/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one/2 .","ref":"Discogs.Repo.html#one/2","title":"Discogs.Repo.one/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one!/2 .","ref":"Discogs.Repo.html#one!/2","title":"Discogs.Repo.one!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.preload/3 .","ref":"Discogs.Repo.html#preload/3","title":"Discogs.Repo.preload/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/3 for more information.","ref":"Discogs.Repo.html#query/3","title":"Discogs.Repo.query/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/3 for more information.","ref":"Discogs.Repo.html#query!/3","title":"Discogs.Repo.query!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.rollback/1 .","ref":"Discogs.Repo.html#rollback/1","title":"Discogs.Repo.rollback/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.start_link/1 .","ref":"Discogs.Repo.html#start_link/1","title":"Discogs.Repo.start_link/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stop/2 .","ref":"Discogs.Repo.html#stop/2","title":"Discogs.Repo.stop/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stream/2 .","ref":"Discogs.Repo.html#stream/2","title":"Discogs.Repo.stream/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that translates the given query to SQL. See Ecto.Adapters.SQL.query/3 for more information.","ref":"Discogs.Repo.html#to_sql/2","title":"Discogs.Repo.to_sql/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.transaction/2 .","ref":"Discogs.Repo.html#transaction/2","title":"Discogs.Repo.transaction/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update/2 .","ref":"Discogs.Repo.html#update/2","title":"Discogs.Repo.update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update!/2 .","ref":"Discogs.Repo.html#update!/2","title":"Discogs.Repo.update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update_all/3 .","ref":"Discogs.Repo.html#update_all/3","title":"Discogs.Repo.update_all/3","type":"function"},{"doc":"Fetches release data from the Discogs API.","ref":"Discogs.Services.JSONFetch.html","title":"Discogs.Services.JSONFetch","type":"module"},{"doc":"Fetches a User 's release data from the Discogs API. If the responses are paginated, continually fetches to the last page, returning the stitched-up payload. This does not take rate limiting into account and will probably fail if used to fetch from a user with many thousands of releases.","ref":"Discogs.Services.JSONFetch.html#fetch_releases/1","title":"Discogs.Services.JSONFetch.fetch_releases/1","type":"function"},{"doc":"","ref":"Discogs.Services.JSONFetch.html#t:error/0","title":"Discogs.Services.JSONFetch.error/0","type":"type"},{"doc":"Discogs JSON API release payload properties","ref":"Discogs.Services.JSONFetch.html#t:release_json/0","title":"Discogs.Services.JSONFetch.release_json/0","type":"type"},{"doc":"","ref":"Discogs.Services.JSONFetch.html#t:result/0","title":"Discogs.Services.JSONFetch.result/0","type":"type"},{"doc":"","ref":"Discogs.Services.JSONFetch.html#t:success/0","title":"Discogs.Services.JSONFetch.success/0","type":"type"},{"doc":"Massages Discogs JSON properties into attribute maps ready for use by Ecto changesets.","ref":"Discogs.Services.JSONSanitize.html","title":"Discogs.Services.JSONSanitize","type":"module"},{"doc":"Extracts the relevant attributes from Discogs Release JSON needed create an Ecto changeset with valid properties and associations. Includes support for associations: Artist Record Note that this only returns the attributes - not the %Release{} structs themselves.","ref":"Discogs.Services.JSONSanitize.html#get_release_attrs/1","title":"Discogs.Services.JSONSanitize.get_release_attrs/1","type":"function"},{"doc":"%Discogs.Release{} changeset attributes","ref":"Discogs.Services.JSONSanitize.html#t:release_attrs/0","title":"Discogs.Services.JSONSanitize.release_attrs/0","type":"type"},{"doc":"Discogs JSON API release payload properties","ref":"Discogs.Services.JSONSanitize.html#t:release_json/0","title":"Discogs.Services.JSONSanitize.release_json/0","type":"type"},{"doc":"Syncs releases and associated data types and adds them to a user's collection.","ref":"Discogs.Services.SyncUserCollection.html","title":"Discogs.Services.SyncUserCollection","type":"module"},{"doc":"Converts Release attribute maps into %Discogs.Release{} structs, then: upserts the structs along with their associations removes User -&gt; Release associations missing from the release list User -&gt; Release associations can be missing when a user has removed a release from their collection, for example when a release is sold or lost. In that case we want to make sure the association is not cast. This could be restructured to leverage something like Ecto.Multi and upsert associations ( Artist s, Record s, UserRelease s) separately from the Release s.","ref":"Discogs.Services.SyncUserCollection.html#sync/2","title":"Discogs.Services.SyncUserCollection.sync/2","type":"function"},{"doc":"","ref":"Discogs.Services.SyncUserCollection.html#t:release_attrs/0","title":"Discogs.Services.SyncUserCollection.release_attrs/0","type":"type"},{"doc":"discogs_shuffle This is an Elixir library that stores Discogs user collections to a local database and allows interaction via Ecto wrappers.","ref":"readme.html","title":"discogs_shuffle","type":"extras"},{"doc":"make build","ref":"readme.html#installation","title":"discogs_shuffle - Installation","type":"extras"},{"doc":"./discogs Usage: discogs [options] --sync USER Sync a user collection --shuffle USER &lt;N=30&gt; Pick n random records from a user collection","ref":"readme.html#usage","title":"discogs_shuffle - Usage","type":"extras"},{"doc":"make test-unit","ref":"readme.html#tests","title":"discogs_shuffle - Tests","type":"extras"},{"doc":"You might find this library useful if you are an Elixir developer who needs to work with the Discogs API in some form. It includes Ecto mappings for the Discogs User -&gt; Release -&gt; Record and Artist -&gt; Release -&gt; Record relationships, and could be easily extended. I kept the Ecto model structs quite slim, since I originally wrote this repo for a fairly simple use-case (creating a shuffled sample of records to experiment with aleatory DJ mixes). Here are a few more reasons this library might be of interest to Elixir developers: as an example of a tested Ecto library that does not include Phoenix as an example of a library using the uncommon sqlite_ecto2 adapter as an example of a CLI app making very minimal use of Elixir's OptionParser","ref":"readme.html#notes","title":"discogs_shuffle - Notes","type":"extras"},{"doc":"This project uses credo and formatter for style consistency. Please run mix format and mix credo -a --strict before committing changes. Guidelines Testing All public functions for the Ecto models should be tested exhaustively, including changeset/2 . Documentation All public modules and their functions should be documented with the appropriate typespecs. This library uses ExDoc conventions for documentation. You can run mix docs to build the docs and open them in your local environment.","ref":"readme.html#contributing","title":"discogs_shuffle - Contributing","type":"extras"},{"doc":"MIT","ref":"readme.html#license","title":"discogs_shuffle - License","type":"extras"}]